/*
LICENSE
-------
The Anti-Viral License

You may use this source code in any way you like provided that this source code
retains its original licensing terms.  Derivative works of this  source code
must also be licensed under this license,  however,  this  license does not
forbid compiling this source code alongside  source  code  of other licenses
provided that those licenses do not require a change in the licensing of this
source code.  Just use some comments to track what code is of what license,
like any intelligent and rational person might do.   After all, no sane person
thinks that if I glue two books together, I've made a derivative work and
require licensing to sell the result.  Were that the case, it would be illegal
to sell used books with notes written in the margins or papers inserted between
the pages.  Let's not be silly about this.  We all know what it means to derive
something from something else. 

...or, in simpler terms, this license is specifically incompatible with the GNU
GPL, but only because the GNU GPL requires that the GNU GPL be applied to all
source code which is part of a program that includes GNU GPL licensed source
code.  Many other free software licenses, such as the BSD license, make no such
demands and are therefore compatible with this license.   Only licenses which
require the relicensing of this source code are incompatible with this license.
Such licenses are viral in nature, and thus, this is the anti-viral license.
*/
#include "global.h"

int menu_area_list (struct user *puser, int message_id) {

	int a, idx;
	
    switch (message_id) {
	case MENU_CREATE:
    
		menu_stack_push (puser, menu_area_list);
		
	case MENU_DRAW: {
		int index = 1;
		
        packet_send(puser, PACKET_MENU_RESET, 0, 78, 20, 3); 
        packet_send(puser, PACKET_MENU_TEXT, index++, TEXT_CENTER_COLUMN, 0, "Area Index");
        
        idx = 0;
        for (a = 0; a < 13; a++) {
            if (idx >= 25) break;
            if (puser->map->area[idx].user_name[0] != 0) 
                packet_send(puser, PACKET_MENU_LINK, index++, 1, a + 2, 1, idx, 0, puser->map->area[idx].user_name);
            idx++;
            if (puser->map->area[idx].user_name[0] != 0) 
                packet_send(puser, PACKET_MENU_LINK, index++, 40, a + 2, 1, idx, 0, puser->map->area[idx].user_name);
            idx++;
        }
        
		break;}
		
		
	case MENU_COMMAND: {
		int menu_number = -1;
		int menu_name = -1;
		int menu_value = -1;
		int menu_flags = -1;
		unsigned char menu_char[65535]; 
		
		menu_command_parse (puser, &menu_number, &menu_name, &menu_value, &menu_flags, menu_char);

		log_printf (puser, LDEBUG, "area_list menu response bytes=%i, menu=%i, name=%i, value=%i, flags=%i", 
				puser->menu_data_size, menu_number, menu_name, menu_value, menu_flags);	

    	menu_stack_pop (puser);        
    	if (menu_name == 1) {
    		area_player_locate (puser, menu_value);
		}
		
		break;}
	}
	return (1);
}

